/**
 * Copyright (c) 2019 Inomera Research.
 * @author Burak Soykal
 */

#import <Foundation/Foundation.h>
#import <Flutter/Flutter.h>
#import <Netmera/Netmera.h>

@interface FNetmeraService : NSObject

extern NSString* _Nonnull const ON_PUSH_REGISTER;
extern NSString* _Nonnull const ON_PUSH_RECEIVE;
extern NSString* _Nonnull const ON_PUSH_RECEIVE_BACKGROUND;
extern NSString* _Nonnull const ON_PUSH_OPEN;
extern NSString* _Nonnull const ON_PUSH_DISMISS;
extern NSString* _Nonnull const ON_PUSH_BUTTON_CLICKED;

/// Dart callbacks are called when ready and create the MethodChannel.
/// - Parameters:
///   - call: FlutterMethodCall
///   - registrar: FlutterPluginRegistrar
+(void) initService:(nonnull FlutterMethodCall *)call
        registrar:(nonnull NSObject<FlutterPluginRegistrar>*)registrar;

/// When a job is requested to be executed, it adds the job to the queue if the Method Channel is not ready. If the channel is ready, it will send directly to the Dart side.
/// - Parameters:
///   - action: Name of action
///   - dict: Object to execute
+ (void) handleWork: (nonnull NSString*)action dict:(nullable NSDictionary*)dict;

@end
